/* wc.c
	program to count words, characters and lines in any file 
	(including binary).
	operates similarly to UNIX wc, but does not recognize the s, l and c flags */

#include        <stdio.h>

#define         YES     1
#define         NO      0
#define         NAMELEN 20

   char fname[NAMELEN];
   char buffer[BUFSIZ];

main (argc,  argv)  /* count lines, words, characters in input */

int argc;
char *argv[];

{
   int i,
       c,
       nl,
       nw,
       nc,
       inword,
       nitems;
   
   FILE *fopen(),
        *fp;

   if (argc == 1) 
   {  printf ("WC: no file to process");
      exit (1);
   }

   else
        while (--argc > 0)
                if ((fp = fopen(*++argv, "rb")) == NULL)
                {       printf("WC: can't open %s\n",*argv);
                        exit(1);
                }

   inword = NO;
   nl = nw = nc = 0;
   c = 0;

   while ( fread (buffer, BUFSIZ , 1, fp) > 0  || c != EOF)
                                                 /* returns 1 for full buffer,
                                                    0 for partial buffer w/ 
                                                    EOF */
    {

     for ( i = 0;  i < BUFSIZ  && (c = buffer[i]) != EOF ; i++) 
        {
        ++nc;
        if (c == '\n')
                ++nl;
        if (c == ' ' || c == '\n' || c == '\t')  /* white spaces */
                inword = NO;
        else if (inword == NO) 
               {
                inword = YES;
                ++nw;
                }
        }
     }
   printf("%d %d %d\n", nl, nw, nc);
}

